#define IOZONE_USAGE "\tUsage:\tio_nfs [megabytes] [record_length_in_bytes] [[path]filename]\n\t\tio_nfs auto[=filename]\n\tio_nfs raw[=filename]\n\tio_nfs cdrom[=filename]\n\t\tio_nfs help\n\n"
#define THISVERSION "2.0.13-san"
#define RELEASEDATE "28-Feb-2008"

/*******************************************************************************
 * $Header: /cygdrive/d/cvs/src/c/io_nfs/io_nfs.c,v 1.8 2008/03/04 22:01:37 Ralph Exp $
 * $Log: io_nfs.c,v $
 * Revision 1.8  2008/03/04 22:01:37  Ralph
 * 2.0.13 upstream with small enhancements
 *
 * Revision 1.7  2004/09/08 16:31:53  ralproth
 * Changes for keystone testing
 *
 * Revision 1.6  2004/05/03 19:08:08  ralproth
 * Bugfixing/Misc. stuff
 *
 * Revision 1.5  2004/04/27 17:06:17  ralproth
 * 2.0.8 - format/kb changed
 *
 * Revision 1.4  2004/04/08 19:42:48  ralproth
 * Modified for SAN (XP, VA & EVA) relative performance checking
 *
 * Revision 1.3  2001/11/08 21:43:34  ralph
 * Enhanced to compile with BCC32 5.5
 *
 * Revision 1.2  2001/11/07 05:56:04  ralph
 * Sources from the Notebook (TC++3.00 fixes)
 *  ",
 * Revision 1.1.2  2001/04/20 10:17:32  administrator
 * Misc. copyrigth/help text changed.
 * removed DOS cr/lf
 *  ",
 * Revision 1.1.1.1  2001/04/20 09:54:06  administrator
 * IO_NFS 2.05 imported to CVS
 *
 * DO NOT PUT the cvs log into the help screen it will be messed up!
 ******************************************************************************/

/* TODO (Ralph#4#): 21 C:\src\c\io_nfs\io_nfs.c:423
                    [Warning] multi-line string literals are deprecated 

bash-3.2$ pscan io_nfs.c
io_nfs.c:596 SECURITY: printf call should have "%s" as argument 0
io_nfs.c:717 SECURITY: printf call should have "%s" as argument 0
bash-3.2$ pscan -w io_nfs.c
io_nfs.c:918 Warning: printf uses non-constant string for format argument 0.
io_nfs.c:1053 Warning: printf uses non-constant string for format argument 0.                    
 */


char *help[] = {
                   "    'IO Zone' - Universal IO/NFS/SAN Benchmark Program",
                   "    hacked by Ralph.Roth@hp.com for ASM/SAN/NFS needs :-)) ",
                   "    http://come.to/rose_swe & http://come.to/cfg2html",
                   "    $Id: io_nfs.c,v 1.8 2008/03/04 22:01:37 Ralph Exp $",
                   "------------------------------------------------------------------",
                   "    Modified/enhanced for NFS performance tuning....",
                   "      + enhanced statistics",
                   "      + auto-mode: blocksize for NFS monitoring (HFS/VxFS)",
                   "      + uses fsync() to bypass disk cache",
                   "      + designed to bypass the cache of HP AutoRAIDs",
                   "      + fixed all errors DJGPP 2.7.2/DOS32, 2.9.5/cygwin claims",
                   "      + fixed all errors DJGPP 2.7/Linux 2.0.32 claims",
                   "      + fixed division by zero errors",
                   "------------------------------------------------------------------",
                   "    Modified for SAN (XP, VA & EVA) relative performance checking",
                   "      + enhanced blocksize and buffersize",
                   "      + works with gcc 3.2, 3.3",
                   "      + fixed default filename (*NIX)",
                   "------------------------------------------------------------------",
                   "" };

/******************************************************************

  INCLUDE FILES (system-dependent)

  ******************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

/*  Define the following if you have a generic System V R3 system which
is not one of the specific versions listed above
*/
/* #define SVR3 */
#ifdef SVR3
#ifndef OS_TYPE
#define OS_TYPE "'Generic' UNIX System V Release 3 -- vendor unknown"
#endif
#include <fcntl.h>
#include <sys/types.h>
#define SysVtime
#endif
/* V1.15 -- add Apollo Domain O/S to the list -- it also worked in previous
versions, now it will print its identity
*/
#ifdef apollo
#ifndef OS_TYPE
#define OS_TYPE "Apollo Domain/OS -- using BSD libraries"
#define BSDtime
#define USE_FSYNC
#endif
#endif

/* V1.14 -- use calloc instead of stack for buffer, on all platforms */
#define usecalloc
/*
V1.14b -- check for ultrix which uses sysconf in newer POSIX version
but uses BSD-style time in the pre-POSIX versions
V1.15 use fsync() for ultrix even though V4.2 will pick up other options
from POSIX
*/
#ifdef ultrix
#ifndef OS_TYPE
#define OS_TYPE "ULTRIX 4.0 or earlier"
#define BSDtime
#define USE_FSYNC
#endif
#endif
/* V1.13 -- support NeXT by treating it like a Sun... Thanks Axel! */
#ifdef __NeXT__
#ifndef OS_TYPE
#define OS_TYPE "NeXT OS"
#endif
#define sun
#endif
/*
  define nolimits if your system has no limits.h.  Sun's don't but I
  take care of this explicitly beginning with V1.08 of IOzone.
  */
#ifdef sun
#ifndef OS_TYPE
#define OS_TYPE "SunOS"
#endif
#define nolimits
#define BSDtime
#define USE_FSYNC
#endif
/* V1.09 -- Silicon Graphics compile with -DSGI  */
#ifdef SGI
#ifndef OS_TYPE
#define OS_TYPE "Silicon Graphics"
#endif
#define nolimits
#define BSDtime
#endif

/* V1.13 For MIPS RISC/OS and Tandem NonStop-UX*/
#ifdef SYSTYPE_BSD43
#define bsd4_3
#ifndef OS_TYPE
#define OS_TYPE "MIPS RISC/os (BSD 4.3 libraries)"
#endif
#endif

#ifdef SYSTYPE_SYSV
#include <sys/utsname.h>
#define nolimits
#ifdef T_NONSTOP
#define OS_TYPE "TANDEM NonStop-UX (System V libraries)"
#endif
#ifndef OS_TYPE
#define OS_TYPE "MIPS RISC/os (System V libraries)"
#endif
#define SysVtime
#include <sys/types.h>
#include <sys/times.h>
#include <sys/fcntl.h>
#endif
/* V1.14 -- define nolimits and BSDtime for Xenix 2.3.3 */
/* incl definitions of O_* flags for XENIX */
#ifdef M_UNIX
#define SCOunix
#else
#ifdef M_XENIX
#define SCOxenix
#endif
#endif

/* SCO Unix System V */
#ifdef SCOunix
#define OS_TYPE "SCO UNIX System V/386"
#include <sys/types.h>
#include <sys/fcntl.h>
#endif

#ifdef SCOxenix
#ifdef XENIX_2_3
#define OS_TYPE "SCO XENIX 2.3.x"
#define BSDtime
#else
#define OS_TYPE "SCO XENIX 3.x"
#define SysVtime
#endif
#endif

/* V1.12 -- test for POSIX-conformant operating system; requires limits.h */
/*
V1.15 -- I have been told that there is a problem in the times() POSIX
function in Ultrix V4.1 and greater.  It seems to return the time in
whole seconds (expressed in terms of clock ticks) instead of correctly
returning the elapsed time in clock ticks ALTHOUGH POSIX 1003.1-1990
and ISO 9945 CLEARLY STATE that "times() shall return the elapsed real
time, in clock ticks."

This means calling times() twice in the same second and subtracting
the two values, produces an answer of 0, which IOzone detects as an error.

I thought I had a problem in V1.14 under Ultrix with loss of precision,
i.e. taking the difference of two large floating point numbers,
but the problem seems be that Ultrix times() *inherently* has a
loss of precision, so my "fix" can't fix the broken system call.
Until they fix it in Ultrix I am going to use BSD-style everything
for Ultrix
*/
#ifndef nolimits

#include <limits.h>
#ifdef _POSIX_ARG_MAX
#ifndef ultrix
#ifndef OS_TYPE
#define OS_TYPE "POSIX 1003.1-1990"
#endif
#define isposix
/* #undef USE_FSYNC */                  /* changed by Ralph Roth */
#define USE_FSYNC
#else
/* It's ultrix disguised as POSIX; still use BSD calls until they fix it */
#undef OS_TYPE
#define OS_TYPE "ULTRIX 4.1 or later"
#endif
#endif
#endif

/* Tandem's GUARDIAN operating system */
#include <stdio.h>
#ifdef __TANDEM
#ifndef OS_TYPE
#define OS_TYPE "TANDEM GUARDIAN 90"
#endif
#define nosignals
#define ANSItime
#define ANSI_MAIN
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#endif

#ifndef nosignals
#include <signal.h>
#endif

#ifdef  __MSDOS__               /* Turbo C define this way for PCs... */
#include <math.h>
#ifndef MSDOS
#define MSDOS                   /* Microsoft C defines this */
#endif                          /* rar, DJGPP port */
#endif
/* VMS and MS-DOS both have ANSI C compilers and use rand()/srand() */
#ifdef  VMS_POSIX
#undef   VMS
#define ANSI_RANDOM     1
#endif
#ifdef  MSDOS
#define ANSI_RANDOM     1
#endif
/* Convergent Technologies M680xx based with Unisys/AT&T Sys5r3 */
#ifdef CONVERGENT
#ifndef OS_TYPE
#define OS_TYPE "Convergent Technologies"
#endif
#include <fcntl.h>
#define SysVtime
#endif
/* Interactive UNIX System V Release 3.2 */
#ifdef isc386
#ifndef OS_TYPE
#define OS_TYPE "Interactive UNIX System V/386"
#endif
#include <fcntl.h>
#define SysVtime
#endif

/* V1.11 -- With the following includes, AIX no longer requires -Dunix */
#ifdef _AIX
#ifndef OS_TYPE
#define OS_TYPE "AIX"
#endif
#include <fcntl.h>
#include <sys/time.h>
#endif

#if defined(VMS)
#ifndef OS_TYPE
#define OS_TYPE "VAX/VMS"
#endif
#define ANSItime
#define ANSI_RANDOM     1
#include    <math.h>
#include    <unixio.h>
#include    <ssdef.h>
#include    <file.h>
#include    <time.h>

#else
/* ... either MSDOS, POSIX, or a generic non-POSIX UNIX */
#ifdef MSDOS
#ifndef OS_TYPE
#define OS_TYPE "MS-DOS"
#endif
#define usecalloc
#include <fcntl.h>
#include <time.h>
#endif
/* nope, not MS-DOS, try POSIX */
#ifdef isposix
#include <time.h>
#include <sys/times.h>
#include <fcntl.h>
#include <unistd.h>
#else
#ifdef unix
#include <fcntl.h>
#else
#ifndef O_RDONLY
#define O_RDONLY 0
#endif
#endif
#endif
#endif

/* for systems with System V-style time, define SysVtime */
#ifdef M_SYSV
#define SysVtime
#endif

/* for systems with BSD style time, define BSDtime */
#ifdef bsd4_2
#define USE_FSYNC
#ifndef OS_TYPE
#define OS_TYPE "BSD 4.2"
#endif
#define BSDtime
#endif
#ifdef bsd4_3
#define USE_FSYNC
#ifndef OS_TYPE
#define OS_TYPE "BSD 4.3"
#endif
#define BSDtime
#endif
/*
If we made it this far and still don't know which operating system
we are running, check if we at least have ANSI C so we can do some
kind of time functions.  On the other hand, if we know what O/S
we are running use the (more precise) time routines for that O/S,
even if we do have ANSI C.  If we don't know what O/S we are and
we don't have ANSI C, but we are some flavor of UNIX, I will use
time() which any UNIX will have.  For the worst case we are not
any form of UNIX nor a supported proprietary O/S, and we don't have
ANSI C either,  one of two things will happen:
1. If you define NOTIMER then you will have to use a stopwatch
2. If NOTIMER not defined, we will assume we can use time()
*/
#ifndef OS_TYPE
#ifdef __STDC__
#define OS_TYPE "ANSI C"
#define ANSItime
#include    <time.h>
#endif
#endif

#ifndef OS_TYPE
#ifdef unix
#define OS_TYPE "UNIX (can't tell if System V or BSD) -- using time()"
#define ANSItime
#include    <time.h>
#endif
#endif

#ifndef OS_TYPE
#if NOTIMER
#define OS_TYPE "System type unknown & not ANSI C -- disabling timing"
#define noclock 1
#else
#define OS_TYPE "System type unknown & not ANSI C -- using time()"
#define ANSItime
#include    <time.h>
#endif
#endif

#ifdef SysVtime
#undef BSDtime
#include <sys/times.h>
#include <sys/param.h>
#ifndef CLK_TCK
#define CLK_TCK HZ
#endif
#endif

#ifdef BSDtime
#undef SysVtime
#include <sys/time.h>
#endif

/******************************************************************

  DEFINED CONSTANTS

  ******************************************************************/
/* Define NULL in case we don't have it... */
#ifndef NULL
#define NULL 0
#endif
/*
  V1.14: Define ONETEST to run a single test at runtime as the default
  V1.14: Define AUTOTEST to run in auto test mode as the default
  i.e. the behavior of IOzone when it is invoked with no arguments.  ONETEST
  makes IOzone run a single test using a 1 MB file and 512 byte records.
  AUTOTEST causes IOzone to use auto test mode.
  For compatibility with previous versions of IOZONE, ONETEST is the default
  setting
*/
#define ONETEST 1
#ifndef ONETEST
#define AUTOTEST
#endif

/*
  V1.14: Define USE_FSYNC to force writes to disk during the write phase
  BSD and BSD-derived UNIX variants and also SVR4 are known to have fsync
  UNIX).  After the file is written and before it is closed, call fsync()
  to force the data to be written from cache to disk.  This (mostly) cancels
  the fact that systems with a lot of memory for cache buffers or memory
  mapping display artificially high transfer rates during the write phase
  of IOzone, because the data never makes it onto the disk.

*/
#if 0
#define USE_FSYNC
#endif

#define MEGABYTES 1                     /* number of megabytes in file */
#define RECLEN  512                     /* number of bytes in a record */
#define FILESIZE 1048576                /*size of file in bytes */
#define NUMRECS 2048                    /* number of records */
#define MAXBUFFERSIZE 65536*2+1         /* maximum buffer size */
#define MINBUFFERSIZE 16
#define TOOFAST 10
/* TODO (rar#9#): Put here a nicer logo! */

/* "28-July-1999" "05-March-1999"  "28-July-98" */

/* Define only one of the following two.  All modern operating systems
   have time functions so let TIME be defined */
#ifndef noclock
#define TIME 1
#endif

#define MAXNAMESIZE 1000                /* max # of characters in filename */
#define CONTROL_STRING1 "\t%-8ld%-8ld%-20ld%-20ld\n"
#define CONTROL_STRING2 "\t%-8s%-8s%-20s%-20s\n"
/* ------------------------------------------------------------------------
  For 'auto mode', these defines determine the number of iterations
  to perform for both the file size and the record length.
  I.e., if MEGABYTES_ITER_LIMIT = 5 use 1, 2, 4, 8 & 16 megabyte files
  if RECLEN_ITER_LIMIT = 5 use 512, 1024, 2048, 4096 & 8192 byte records (5 is max)
  */

/* Compile with -DUSEXP to create larger files e.g. to test SAN arrays */

#ifdef USEXP
/* 6, 8, 12, 20, 36 (5), 68 (6), 132 (7), 260 (8), 516 (9)     */
/* 1028 (10), 2052 (11) */
#define MEGABYTES_ITER_LIMIT 9          /* fixed by Ralph Roth */
#define RECLEN_ITER_LIMIT 6		/* MAX */
#else
#define MEGABYTES_ITER_LIMIT 5          /* fixed by Ralph Roth */
#define RECLEN_ITER_LIMIT 4		/* default = 3 */
#endif
/******************************************************************

  MACRO DEFINITIONS

  ******************************************************************/
#ifndef abs
#define abs(X) ( (X) < 0 ? (-(X)) : (X) )  /* Absolute value of X */
#endif
/******************************************************************

  FUNCTION DECLARATIONS


  ******************************************************************/
void auto_test();               /* perform automatic test series */
void show_help();               /* show development help*/
double time_so_far();           /* time since start of program */
void signal_handler();          /* clean up if user interrupts us */
void statistics();
/******************************************************************

  GLOBAL VARIABLES

  ******************************************************************/

int auto_mode=0, raw_mode=0, cdrom_mode=0;
char filename [MAXNAMESIZE];            /* name of temporary file */
char *fname;
unsigned long lTotalFile = 0;
/* unsigned */
double lTotalTimeR = 0.0, lTotalTimeW = 0.0;

/******************************************************************

  MAIN -- entry point

  ******************************************************************/
#ifdef ANSI_MAIN
int main(int argc, char *argv[], char *env[])    /* main body of code */
#else
int main(argc,argv)
int argc;
char *argv[];
#endif
{
#ifdef ANSI_MAIN
    char *fooenv;
#endif

    int fd;
    char *default_filename;

#ifdef  usecalloc

    char *buffer;
#else

    char buffer [MAXBUFFERSIZE];            /*a temporary data buffer*/
#endif

    unsigned long i;
    unsigned long megabytes = MEGABYTES;
    unsigned long reclen = RECLEN;
    unsigned long filesize;
    unsigned long numrecs;
    unsigned long thisrec;
#ifdef TIME

    unsigned long filebytes;
    unsigned long readrate, writerate;
    unsigned long goodmegs;
    unsigned long goodrecl;
    double starttime;
    double writetime = 0, readtime = 0;
    double totaltime;
#endif
#ifdef usecalloc

    buffer = (char *) calloc(1, MAXBUFFERSIZE);
#endif

#if defined (ANSI_MAIN)

    fooenv= env[0];       /* dummy so we make some use of env (to avoid warnings) */
#endif

#if defined (__TANDEM)

    default_filename ="IOZONET"; /* TANDEM GUARDIAN 90 has max 8 char filenames */
#else

    default_filename ="#ioZone_NFS+SAN#.temp.bak";     /*default name of temporary file*/
#endif

    if (!auto_mode)
    {
        printf("\nIO-NFS: Test of Sequential File I/O -- %s (%s)\n",
               THISVERSION, RELEASEDATE);
#ifdef USE_FSYNC

        printf("\tOperating System: %s -- using fsync()\n\n", OS_TYPE);
#else

        printf("Operating System: %s\n", OS_TYPE);
#endif
#ifndef nosignals

        signal(SIGINT, signal_handler);      /* handle user interrupt */
        signal(SIGTERM, signal_handler);     /* handle kill from shell */
#endif

    }
    switch (argc)
    {
    case 1:     /* no args, take all defaults */
        strcpy(filename,default_filename);
        printf("%s\n",IOZONE_USAGE);
#ifdef AUTOTEST

        auto_mode = 1;
        auto_test();
        printf("Completed series of tests\n");
        exit(0);
#endif

        break;
    case 2:     /* <megabytes|filename> */
        if (!auto_mode)
        {
            strcpy(filename,default_filename);
        }
        i = (unsigned) abs(atoi(argv[1]));
        if (i)
        {
            megabytes = i;
        }
        else
        {
            /*
              'Auto mode' will be enabled if the first command line argument is
              the word 'auto'.  This will trigger a series of tests
              V2.01 if you say 'raw' it does the auto test in raw mode, i.e.
              does not delete the file.
              If you say 'cdrom' it does it in cdrom mode, i.e. raw mode but
              only test reads -- since a CD ROM cant do writes!
              This options processing would be so much easier if I had the
              luxury of getopt, but alas, that is not portable to all non-UNIX
              operating systems and C compilers.

              */
            if ( (strncmp(argv[1], "auto", 4) == 0) ||
                    (strncmp(argv[1], "AUTO", 4) == 0) )
            {
                fname = argv[1];

                if (fname[4] == '=')      /* check for =filename */
                {
                    strcpy(filename, &(fname[5]));
                }

                auto_mode = 1;
                auto_test();
                printf("Completed series of tests\n");
                exit(0);
            }
            else if ( (strncmp(argv[1], "raw", 3) == 0) ||
                      (strncmp(argv[1], "RAW", 3) == 0) )
            {
                fname = argv[1];

                if (fname[3] == '=')      /* check for =filename */
                {
                    strcpy(filename, &(fname[4]));
                }

                auto_mode = 1;
                raw_mode = 1;
                auto_test();
                printf("Completed series of tests\n");
                exit(0);
            }
            else if ( (strncmp(argv[1], "cdrom", 5) == 0) ||
                      (strncmp(argv[1], "CDROM", 5) == 0) )
            {
                fname = argv[1];

                if (fname[5] == '=')      /* check for =filename */
                {
                    strcpy(filename, &(fname[6]));
                }

                auto_mode = 1;
                cdrom_mode = 1;
                raw_mode = 1;
                auto_test();
                printf("Completed series of tests\n");
                exit(0);
            }
            else
            {
                auto_mode = 0;
            }
            if ( (strcmp(argv[1], "help") == 0) ||
                    (strcmp(argv[1], "HELP") == 0) )
            {
                show_help();
                exit(0);
            }
            strcpy(filename,argv[1]);
        }
        break;
    case 3:     /* <megabytes> <reclen|filename> */
        if (!auto_mode)
        {
            strcpy(filename,default_filename);
        }
        megabytes = (unsigned) atoi(argv[1]);
        if (atoi(argv[2]))
        {
            reclen = atoi(argv[2]);
        }
        else
        {
            strcpy(filename,argv[2]);
        }
        break;
    case 4:     /* <megabytes> <reclen> <filename> */
        if (!auto_mode)
        {
            strcpy(filename,default_filename);
        }
        megabytes = (unsigned) atoi(argv[1]);
        reclen = atoi(argv[2]);
        strcpy(filename,argv[3]);
        break;
    default:
        printf("io_nfs: bad usage\n");
        printf("%s\n", IOZONE_USAGE);
        exit(1);

    }
    filesize = (unsigned long) (1024L*1024L*megabytes);
    numrecs =  filesize/(unsigned long) reclen;
    if (reclen >  MAXBUFFERSIZE)
    {
        printf("Error: Maximum record length is %d bytes\n", MAXBUFFERSIZE);
        exit(1);
    }
    if (reclen < MINBUFFERSIZE)
    {
        printf("Error: Minimum record length is %d bytes\n", MINBUFFERSIZE);
        exit(1);
    }
    if (!auto_mode)
    {
        printf("\tio_nfs writes a %ld Megabyte sequential file consisting of\n",
               megabytes);
        printf("\t%ld records which are each %ld bytes in length.\n",
               numrecs, reclen);
        printf("\tIt then reads the file.  It prints the bytes-per-second\n");
        printf("\trate at which the computer can read and write files.\n\n");
        printf("\nWriting the %ld Megabyte file, '%s'...", megabytes, filename);
    }
    if (!cdrom_mode)
    {
#ifdef __TANDEM
#ifndef _XOPEN_SOURCE
        /*
           Tandem's GUARDIAN preallocates file space based on primary- and secondary extents.
          The last 2 parameters to open are the sizes of the primary- and secondary extents,
          in blocks which are 2K bytes each.  After the primary extent is filled, GUARDIAN
          allocates up to 15 additional extents, one at a time.
          */
#define SPECIAL_CREAT
#define PRI_EXT_BLOCKS 1024
#define SEC_EXT_BLOCKS 1024
        if((fd = creat(filename, 0640,
                       PRI_EXT_BLOCKS, SEC_EXT_BLOCKS))<0)
        {
            printf("Cannot create temporary file: %s\n", filename);
            exit(1);
        }
#endif
#endif
        /* TODO (Ralph#2#): 707 C:\src\c\io_nfs\io_nfs.c
                            `O_WRONLY' undeclared (first use in this function) */

#ifndef SPECIAL_CREAT
        if (raw_mode)  /* raw mode devices already exist, dont create */
        {
            if((fd = open(filename, O_WRONLY, 0640))<0)
            {
                printf("Cannot open raw device: %s\n", filename);
                perror("io_nfs");
                exit(1);
            }
        } else
        {
            if((fd = creat(filename, 0640))<0)
            {
                printf("Cannot create temporary file: %s\n", filename);
                exit(1);
            }
        } /* if (raw_mode) */
#endif
#ifdef TIME
        starttime = time_so_far();
#endif
#ifndef TIME

        printf("\nstart timing\n");
#endif

        for(thisrec=0; thisrec<numrecs; thisrec++)
        {
            memset(buffer, rand()*255, MAXBUFFERSIZE);
            /*
            int nT;
            for (nT = 0; nT < MAXBUFFERSIZE; nT++)
            	buffer[nT] = rand()*256;
            */
#ifndef DEBUG_ME

            if(write(fd, buffer, (unsigned) reclen) != (int) reclen)
            {
                printf("Error writing block %ld\n", thisrec);
                perror("io_nfs");
                close(fd);
#ifndef VMS
#ifndef NO_DELETE

                if (!raw_mode)
                {
                    unlink(filename);   /* delete the file */
                }
#endif
                /*stop timer*/
#endif
                exit(1);
            }
#endif

        }
#ifdef USE_FSYNC
        fsync(fd);
#endif
#ifdef TIME

        writetime = time_so_far() - starttime;
        if (!auto_mode)
        {
            printf("%f seconds", writetime);
        }
#endif
#ifndef TIME
        printf("\nstop timing\n");
#endif

        close(fd);
    } /* if (!cdrom_mode) */
#if defined (VMS)
#define SPECIAL_OPEN_READ
    if((fd = open(filename, O_RDONLY, 0640))<0)
    {
        printf("Cannot open temporary file for read\n");
        exit(1);
    }
#endif

#ifdef MSDOS
#define SPECIAL_OPEN_READ
    if((fd = open(filename, O_RDONLY, 0640))<0)
    {
        printf("Cannot open temporary file for read\n");
        exit(1);
    }
#endif

    /*  'Generic' case, compiled if no operating system-specific case was invoked
     */
#ifndef SPECIAL_OPEN_READ
    if((fd = open(filename, O_RDONLY))<0)
    {
        printf("Cannot open temporary file for read\n");
        exit(1);
    }
#endif

    /*start timing*/
    if (!auto_mode)
    {
        printf("\nReading the file...");
    }
#ifndef TIME
    printf("\nstart timing\n");
#endif
#ifdef TIME

    starttime = time_so_far();
#endif

    for(thisrec=0; thisrec<numrecs; thisrec++)
    {
#ifndef DEBUG_ME
        if(read(fd, buffer, (unsigned) reclen) != (int) reclen)
        {
            printf("Error reading block %ld\n", thisrec);
            exit(1);
        }
#endif

    }
#ifndef TIME
    printf("\nstop timing\n");
#endif
#ifdef TIME

    readtime = time_so_far() - starttime;
    if (!auto_mode)
    {
        printf("%f seconds\n", readtime);
    }
#ifdef DEBUG_ME
    readtime = 1;
    writetime = 1;
#endif

    if(readtime!=0)
    {
        filebytes = numrecs* (unsigned long) reclen;
        readrate = (unsigned long) ((double) filebytes / readtime);
        writerate = (unsigned long) ((double) filebytes / writetime);
        lTotalFile  += filebytes;
        lTotalTimeR += (double) readtime;
        lTotalTimeW += (double) writetime;

        if (auto_mode)
        {
                printf(CONTROL_STRING1, megabytes, reclen, writerate, readrate);
        }
        else
        {
            /*
                      printf("\nio_nfs performance measurements:\n");
                      printf("\t%ld bytes/second for writing the file\n", writerate);
                      printf("\t%ld bytes/second for reading the file\n", readrate);
            */
            totaltime = readtime + writetime;
            statistics();

            if (totaltime < TOOFAST)
            {
                goodmegs = (TOOFAST/totaltime)*2*megabytes;
                printf("\nThe test completed too quickly to give a good result\n");
                printf("You will get a more precise measure of this machine's\n");
                printf("performance by re-running io_nfs using the command:\n");
                printf("\n\tio_nfs %ld ", goodmegs);
                printf("\t(i.e., file size = %ld megabytes)\n", goodmegs);
            }
        }
    }
    else
    {
        goodrecl = reclen/2;
        printf("\nI/O error during read.  Try again with the command:\n");
        printf("\n\tio_nfs %ld %ld ", megabytes,  goodrecl);
        printf("\t(i.e. record size = %ld bytes)\n",  goodrecl);
    }
#endif
    close(fd);
#ifndef VMS
#ifndef NO_DELETE

    if (!raw_mode)
    {
        unlink(filename);   /* delete the file */
    }
#endif
    /*stop timer*/
#endif
#ifdef  usecalloc
    free(buffer);           /* deallocate the memory */
#endif
#ifdef VMS

    return SS$_NORMAL;
#else

    return 0;
#endif
}


/******************************************************************

  SHOW_HELP -- show development help of this program

  ******************************************************************/
void
show_help()
{
    int i;
    printf("%s", IOZONE_USAGE);
    printf("io_nfs: help mode\n");
    for(i=0; strlen(help[i]); i++)
    {
        printf("%s\n", help[i]);
    }
    puts("Bye!");
}
/******************************************************************

  SIGNAL_HANDLER -- clean up if user interrupts the program

  ******************************************************************/
void
signal_handler()
{
    printf("\nio_nfs: interrupted\n\n");
#ifndef VMS
#ifndef NO_DELETE

    if(!raw_mode)
    {
        printf("deleting file: %s\n", filename);
        unlink(filename);   /* delete the file */
    }
#endif
#endif
    printf("exiting io_nfs\n\n");
    exit(0);
}
/******************************************************************

  AUTO_TEST -- perform series of tests and tabulate results

  ******************************************************************/
#ifndef O_WRONLY
#define	O_WRONLY O_RDWR
#endif


void
auto_test()
{

    int megsi, recszi;
    int xmegsi, xrecszi;
    char megs[10];
    char recsz[10];
    int i,j;
    int autoArgc = 3;
    char *autoArgv[3];

    printf("io_nfs: auto-test mode ");
    if (cdrom_mode)
    {
        printf("CD-ROM device %s\n\n", filename);
    }
    else if (raw_mode)
    {
        printf("raw device %s\n\n", filename);
    }
    else
    {
        printf("\n\n");
    }

    printf(CONTROL_STRING2,
           "MB",   "reclen",
           "bytes/sec written",
           "bytes/sec read");
    autoArgv[0] = "io_nfs auto-test";
    autoArgv[1] = megs;
    autoArgv[2] = recsz;
    /*
      Start with file size of 1 megabyte and repeat the test MEGABYTES_ITER_LIMIT
      times.  Each time we run, the file size is doubled
      For raw mode and CD-ROM mode, file sizes start at 1 MB and record
      sizes start at 16K bytes
      */
    if (raw_mode || cdrom_mode)
    {
        xmegsi=1;
        xrecszi=4096;
    }
    else
    {                    /* Auto Mode */
        xmegsi=6;                 /* 4 MB Ralph Roth */
        xrecszi=1024*4;           /* 4k bytes chunks */
    }
    for(i=0, megsi=xmegsi;i<MEGABYTES_ITER_LIMIT;i++,megsi=megsi*2-4)
    {
        sprintf(megs, "%d", megsi);
        /*
          Start with record size of 512 bytes and repeat the test RECLEN_ITER_LIMIT
          times.  Each time we run, the record size is doubled
          */
        for (j=0,recszi=xrecszi;j<RECLEN_ITER_LIMIT;j++,recszi*=2)
        {
            sprintf(recsz, "%d", recszi);
#ifdef ANSI_MAIN

            main(autoArgc, autoArgv, NULL);
#else

            main(autoArgc, autoArgv);
#endif

        }
    }
    if (auto_mode == 1)
        statistics();
}

#ifdef TIME
/******************************************************************

  TIME_SO_FAR -- return elapsed time

  5/17/91 Bill Norcott        V1.07 -- use time() for VMS
  The times() function in VMS returns proc & user CPU time in 10-millisecond
  ticks.  Instead, use time() which lacks the precision but gives clock
  time in seconds.
  V1.14 make val of type clock_t if we are dealing with POSIX
  V1.15 first time this is called, set base to initial number of clock
  ticks, then subtract this value from all subsequent calculations.  This
  will fix a loss of precision when times returns very big numbers;

  Here is what we check for (in order).  Each returns so we do not
  have to nest the #ifdefs -- should satisfy even the dumbest
  pre-processor.  Note that each has its own flavor of timekeeping
  1. ANSI C
  2. POSIX - with and without CLK_TCK defined
  3. System V variants
  4. MS-DOS
  5. BSD variants
  ******************************************************************/
double
time_so_far()
{
#if defined(ANSItime)
    return (double) time(NULL);
#endif

#ifdef isposix

    {
        static clock_t base, val;
        struct tms tms;

        if (base == 0)
        {
            base = times(&tms);
            if (base == (clock_t) -1)
            {
                perror("times");
            }
        }
        val = times(&tms);
        if (val == (clock_t) -1)
        {
            perror("times");
        }
        val = val - base;
#ifndef CLK_TCK

        return ((double) val) / ((double) sysconf(_SC_CLK_TCK));
#else
#ifdef MSDOS

        return ((double) val) / ((double) CLOCKS_PER_SEC);
#else

        return ((double) val) / ((double) CLK_TCK);
#endif
#endif

    }
#endif

#ifdef SysVtime
    {
        static long base, val;
        struct tms tms;

        if (base == 0)
        {
            if ((base = times(&tms)) == -1)
            {
                perror("times");
            }
        }
        if ((val = times(&tms)) == -1)
        {
            perror("times");
        }
        val = val - base;
        return ((double) val) / ((double) CLK_TCK);
    }
#endif

#if defined(MSDOS)
    return ((double) clock()) / ((double) CLK_TCK);
#endif

#ifdef BSDtime

    {
        struct timeval tp;

        if (gettimeofday(&tp, (struct timezone *) NULL) == -1)
            perror("gettimeofday");
        return ((double) (tp.tv_sec)) +
               (((double) tp.tv_usec) / 1000000.0);
    }
#endif
}
#endif


void statistics()
{
    /* grep for #### to get summary only :) */
    printf("\n Average statistics\n");
    printf("####\t Total KB= %8.0f (1024), read=%4.2f (sec), write=%4.2f (sec)\n",
           (double) (lTotalFile/1024), lTotalTimeR, lTotalTimeW);

    /* add 1/100 to avoid div. by zero errors */
    printf("####\t Average read=%8.2f MB/sec, write=%8.2f MB/sec\n",
           (double) lTotalFile/(lTotalTimeR+0.01)/1024/1024, 
           (double) lTotalFile/(lTotalTimeW+0.01)/1024/1024);

    printf("\n");
}

/* end */
